diff --git a/.indent.pro b/.indent.pro
index dbe34c45..ef1b06ab 100644
--- a/.indent.pro
+++ b/.indent.pro
@@ -84,6 +84,8 @@
 -T lxw_col_options
 -T lxw_col_t
 -T lxw_color_t
+-T lxw_comment
+-T lxw_comment_options
 -T lxw_content_types
 -T lxw_core
 -T lxw_custom
@@ -132,6 +134,8 @@
 -T lxw_styles
 -T lxw_theme
 -T lxw_tuple
+-T lxw_vml
+-T lxw_vml_obj
 -T lxw_workbook
 -T lxw_workbook_options
 -T lxw_worksheet
diff --git a/include/xlsxwriter/comment.h b/include/xlsxwriter/comment.h
new file mode 100644
index 00000000..20e63b23
--- /dev/null
+++ b/include/xlsxwriter/comment.h
@@ -0,0 +1,51 @@
+/*
+ * libxlsxwriter
+ *
+ * Copyright 2014-2019, John McNamara, jmcnamara@cpan.org. See LICENSE.txt.
+ *
+ * comment - A libxlsxwriter library for creating Excel XLSX comment files.
+ *
+ */
+#ifndef __LXW_COMMENT_H__
+#define __LXW_COMMENT_H__
+
+#include <stdint.h>
+
+#include "common.h"
+#include "worksheet.h"
+
+/*
+ * Struct to represent a comment object.
+ */
+typedef struct lxw_comment {
+
+    FILE *file;
+    struct lxw_comment_objs *comment_objs;
+
+} lxw_comment;
+
+
+/* *INDENT-OFF* */
+#ifdef __cplusplus
+extern "C" {
+#endif
+/* *INDENT-ON* */
+
+lxw_comment *lxw_comment_new();
+void lxw_comment_free(lxw_comment *comment);
+void lxw_comment_assemble_xml_file(lxw_comment *self);
+
+/* Declarations required for unit testing. */
+#ifdef TESTING
+
+STATIC void _comment_xml_declaration(lxw_comment *self);
+
+#endif /* TESTING */
+
+/* *INDENT-OFF* */
+#ifdef __cplusplus
+}
+#endif
+/* *INDENT-ON* */
+
+#endif /* __LXW_COMMENT_H__ */
diff --git a/include/xlsxwriter/common.h b/include/xlsxwriter/common.h
index e75ee594..d7a38fc3 100644
--- a/include/xlsxwriter/common.h
+++ b/include/xlsxwriter/common.h
@@ -94,6 +94,9 @@ typedef enum lxw_error {
     /** Unknown zip error when closing xlsx file. */
     LXW_ERROR_ZIP_CLOSE,
 
+    /** Feature is not currently supported in this configuration. */
+    LXW_ERROR_FEATURE_NOT_SUPPORTED,
+
     /** NULL function parameter ignored. */
     LXW_ERROR_NULL_PARAMETER_IGNORED,
 
diff --git a/include/xlsxwriter/content_types.h b/include/xlsxwriter/content_types.h
index 5881c7e5..5c77f8a0 100644
--- a/include/xlsxwriter/content_types.h
+++ b/include/xlsxwriter/content_types.h
@@ -53,6 +53,10 @@ void lxw_ct_add_chart_name(lxw_content_types *content_types,
                            const char *name);
 void lxw_ct_add_drawing_name(lxw_content_types *content_types,
                              const char *name);
+void lxw_ct_add_comment_name(lxw_content_types *content_types,
+                             const char *name);
+void lxw_ct_add_vml_name(lxw_content_types *content_types);
+
 void lxw_ct_add_shared_strings(lxw_content_types *content_types);
 void lxw_ct_add_calc_chain(lxw_content_types *content_types);
 void lxw_ct_add_custom_properties(lxw_content_types *content_types);
diff --git a/include/xlsxwriter/format.h b/include/xlsxwriter/format.h
index bf3c034a..4dd39b4b 100644
--- a/include/xlsxwriter/format.h
+++ b/include/xlsxwriter/format.h
@@ -1206,6 +1206,8 @@ void format_set_font_extend(lxw_format *format);
 void format_set_reading_order(lxw_format *format, uint8_t value);
 void format_set_theme(lxw_format *format, uint8_t value);
 void format_set_hyperlink(lxw_format *format);
+void format_set_color_indexed(lxw_format *format, uint8_t value);
+void format_set_font_only(lxw_format *format);
 
 /* Declarations required for unit testing. */
 #ifdef TESTING
diff --git a/include/xlsxwriter/packager.h b/include/xlsxwriter/packager.h
index a563570c..b1303d34 100644
--- a/include/xlsxwriter/packager.h
+++ b/include/xlsxwriter/packager.h
@@ -29,6 +29,8 @@
 #include "format.h"
 #include "content_types.h"
 #include "relationships.h"
+#include "vml.h"
+#include "comment.h"
 
 #define LXW_ZIP_BUFFER_SIZE (16384)
 
diff --git a/include/xlsxwriter/vml.h b/include/xlsxwriter/vml.h
new file mode 100644
index 00000000..b573b0e6
--- /dev/null
+++ b/include/xlsxwriter/vml.h
@@ -0,0 +1,54 @@
+/*
+ * libxlsxwriter
+ *
+ * Copyright 2014-2019, John McNamara, jmcnamara@cpan.org. See LICENSE.txt.
+ *
+ * vml - A libxlsxwriter library for creating Excel XLSX vml files.
+ *
+ */
+#ifndef __LXW_VML_H__
+#define __LXW_VML_H__
+
+#include <stdint.h>
+
+#include "common.h"
+#include "worksheet.h"
+
+/*
+ * Struct to represent a vml object.
+ */
+typedef struct lxw_vml {
+
+    FILE *file;
+    uint8_t type;
+    struct lxw_comment_objs *button_objs;
+    struct lxw_comment_objs *comment_objs;
+    struct lxw_comment_objs *image_objs;
+    char *vml_data_id_str;
+    uint32_t vml_shape_id;
+
+} lxw_vml;
+
+
+/* *INDENT-OFF* */
+#ifdef __cplusplus
+extern "C" {
+#endif
+/* *INDENT-ON* */
+
+lxw_vml *lxw_vml_new();
+void lxw_vml_free(lxw_vml *vml);
+void lxw_vml_assemble_xml_file(lxw_vml *self);
+
+/* Declarations required for unit testing. */
+#ifdef TESTING
+
+#endif /* TESTING */
+
+/* *INDENT-OFF* */
+#ifdef __cplusplus
+}
+#endif
+/* *INDENT-ON* */
+
+#endif /* __LXW_VML_H__ */
diff --git a/include/xlsxwriter/workbook.h b/include/xlsxwriter/workbook.h
index 76bd96ec..32add9a0 100644
--- a/include/xlsxwriter/workbook.h
+++ b/include/xlsxwriter/workbook.h
@@ -298,6 +298,7 @@ typedef struct lxw_workbook {
     uint16_t num_xf_formats;
     uint16_t num_format_count;
     uint16_t drawing_count;
+    uint16_t comment_count;
 
     uint16_t font_count;
     uint16_t border_count;
@@ -308,6 +309,7 @@ typedef struct lxw_workbook {
     uint8_t has_png;
     uint8_t has_jpeg;
     uint8_t has_bmp;
+    uint8_t has_vml;
 
     lxw_hash_table *used_xf_formats;
 
diff --git a/include/xlsxwriter/worksheet.h b/include/xlsxwriter/worksheet.h
index 307a2ea5..5013aa55 100644
--- a/include/xlsxwriter/worksheet.h
+++ b/include/xlsxwriter/worksheet.h
@@ -55,6 +55,7 @@
 #include "format.h"
 #include "styles.h"
 #include "utility.h"
+#include "relationships.h"
 
 #define LXW_ROW_MAX           1048576
 #define LXW_COL_MAX           16384
@@ -275,6 +276,7 @@ STAILQ_HEAD(lxw_selections, lxw_selection);
 STAILQ_HEAD(lxw_data_validations, lxw_data_val_obj);
 STAILQ_HEAD(lxw_image_props, lxw_object_properties);
 STAILQ_HEAD(lxw_chart_props, lxw_object_properties);
+STAILQ_HEAD(lxw_comment_objs, lxw_vml_obj);
 
 /**
  * @brief Options for rows and columns.
@@ -658,6 +660,102 @@ typedef struct lxw_object_properties {
     STAILQ_ENTRY (lxw_object_properties) list_pointers;
 } lxw_object_properties;
 
+/**
+ * @brief Options for inserted comments.
+ *
+ * Options for modifying comments inserted via `worksheet_write_comment_opt()`.
+ *
+ */
+typedef struct lxw_comment_options {
+
+    /** This option is used to make a cell comment visible when the worksheet
+     *  is opened. The default behavior in Excel is that comments are
+     *  initially hidden. However, it is also possible in Excel to make
+     *  individual comments or all comments visible.  You can make all
+     *  comments in the worksheet visible using the
+     *  `worksheet_show_comments()` function. Defaults to LXW_FALSE.*/
+    uint8_t visible;
+
+    /** This option is used to set the row in which the comment will
+     *  appear. By default Excel displays comments one cell to the right and
+     *  one cell above the cell to which the comment relates. The `start_row`
+     *  and `start_col` options should both be set to 0 if not used.*/
+    lxw_row_t start_row;
+
+    /** This option is used to set the column in which the comment will
+     *   appear. See the `start_row` option for more information. */
+    lxw_col_t start_col;
+
+    /** This option is used to set the width of the cell comment box
+     *  explicitly in pixels. The default width is 128 pixels. */
+    uint16_t width;
+
+    /** This option is used to set the height of the cell comment box
+     *  explicitly in pixels. The default height is 74 pixels. */
+    uint16_t height;
+
+    /** X scale of the comment as a decimal. */
+    double x_scale;
+
+    /** Y scale of the comment as a decimal. */
+    double y_scale;
+
+    /** Offset from the left of the cell in pixels. */
+    int32_t x_offset;
+
+    /** Offset from the top of the cell in pixels. */
+    int32_t y_offset;
+
+    /** This option is used to set the background color of cell comment
+     *  box. The color should be an RGB integer value, see @ref
+     *  working_with_colors. */
+    lxw_color_t color;
+
+    /** This option is used to set the font for the comment. The default font
+     *  is 'Tahoma'. */
+    char *font_name;
+
+     /** This option is used to set the font size for the comment. The default
+      * is 8. */
+    double font_size;
+
+    /** This option is used to set the font family for the comment. Not
+     *  required very often. Set to NULL. */
+    char *font_family;
+
+    /** This option is used to indicate the author of the cell comment. Excel
+     *  displays the author in the status bar at the bottom of the
+     *  worksheet. The default author for all cell comments in a worksheet can
+     *  be set using the `worksheet_set_comments_author()` function. Set to
+     *  NULL if not required.*/
+    char *author;
+
+} lxw_comment_options;
+
+/* Internal structure for VML object options. */
+typedef struct lxw_vml_obj {
+
+    uint8_t visible;
+    uint32_t author_id;
+    lxw_row_t row;
+    lxw_col_t col;
+    lxw_color_t color;
+    double font_size;
+    char *author;
+    char *font_name;
+    char *font_family;
+    char *text;
+    struct lxw_drawing_coords from;
+    struct lxw_drawing_coords to;
+    uint32_t col_absolute;
+    uint32_t row_absolute;
+    uint32_t width;
+    uint32_t height;
+
+    STAILQ_ENTRY (lxw_vml_obj) list_pointers;
+
+} lxw_vml_obj;
+
 /**
  * @brief Header and footer options.
  *
@@ -790,6 +888,7 @@ typedef struct lxw_worksheet {
     struct lxw_image_props *image_props;
     struct lxw_chart_props *chart_data;
     struct lxw_drawing_rel_ids *drawing_rel_ids;
+    struct lxw_comment_objs *comment_objs;
 
     lxw_row_t dim_rowmin;
     lxw_row_t dim_rowmax;
@@ -902,6 +1001,15 @@ typedef struct lxw_worksheet {
     lxw_drawing *drawing;
     lxw_format *default_url_format;
 
+    uint8_t has_vml;
+    uint8_t has_comments;
+    uint8_t has_header_vml;
+    lxw_rel_tuple *external_vml_comment_link;
+    lxw_rel_tuple *external_comment_link;
+    char *default_comment_author;
+    char *vml_data_id_str;
+    uint32_t vml_shape_id;
+
     STAILQ_ENTRY (lxw_worksheet) list_pointers;
 
 } lxw_worksheet;
@@ -935,6 +1043,8 @@ typedef struct lxw_row {
     uint8_t row_changed;
     uint8_t data_changed;
     uint8_t height_changed;
+    uint8_t has_comments;
+
     struct lxw_table_cells *cells;
 
     /* tree management pointers for tree.h. */
@@ -947,6 +1057,7 @@ typedef struct lxw_cell {
     lxw_col_t col_num;
     enum cell_types type;
     lxw_format *format;
+    lxw_vml_obj *comment;
 
     union {
         double number;
@@ -1547,6 +1658,14 @@ lxw_error worksheet_write_rich_string(lxw_worksheet *worksheet,
                                       lxw_rich_string_tuple *rich_string[],
                                       lxw_format *format);
 
+lxw_error worksheet_write_comment_opt(lxw_worksheet *worksheet,
+                                      lxw_row_t row_num, lxw_col_t col_num,
+                                      char *string,
+                                      lxw_comment_options *options);
+
+lxw_error worksheet_write_comment(lxw_worksheet *worksheet,
+                                  lxw_row_t row, lxw_col_t col, char *string);
+
 /**
  * @brief Set the properties for a row of cells.
  *
@@ -3417,6 +3536,9 @@ void worksheet_set_default_row(lxw_worksheet *worksheet, double height,
  */
 lxw_error worksheet_set_vba_name(lxw_worksheet *worksheet, const char *name);
 
+lxw_error worksheet_set_comments_author(lxw_worksheet *worksheet,
+                                        const char *author);
+
 lxw_worksheet *lxw_worksheet_new(lxw_worksheet_init_data *init_data);
 void lxw_worksheet_free(lxw_worksheet *worksheet);
 void lxw_worksheet_assemble_xml_file(lxw_worksheet *worksheet);
@@ -3431,9 +3553,14 @@ void lxw_worksheet_prepare_chart(lxw_worksheet *worksheet,
                                  lxw_object_properties *object_props,
                                  uint8_t is_chartsheet);
 
-lxw_row *lxw_worksheet_find_row(lxw_worksheet *worksheet, lxw_row_t row_num);
-lxw_cell *lxw_worksheet_find_cell(lxw_row *row, lxw_col_t col_num);
+uint32_t lxw_worksheet_prepare_vml_objects(lxw_worksheet *worksheet,
+                                           uint32_t vml_data_id,
+                                           uint32_t vml_shape_id,
+                                           uint32_t vml_drawing_id,
+                                           uint32_t comment_id);
 
+lxw_row *lxw_worksheet_find_row(lxw_worksheet *worksheet, lxw_row_t row_num);
+lxw_cell *lxw_worksheet_find_cell_in_row(lxw_row *row, lxw_col_t col_num);
 /*
  * External functions to call intern XML methods shared with chartsheet.
  */
diff --git a/src/comment.c b/src/comment.c
new file mode 100644
index 00000000..7605fc9d
--- /dev/null
+++ b/src/comment.c
@@ -0,0 +1,321 @@
+/*****************************************************************************
+ * comment - A library for creating Excel XLSX comment files.
+ *
+ * Used in conjunction with the libxlsxwriter library.
+ *
+ * Copyright 2014-2019, John McNamara, jmcnamara@cpan.org. See LICENSE.txt.
+ *
+ */
+
+#include "xlsxwriter/xmlwriter.h"
+#include "xlsxwriter/comment.h"
+#include "xlsxwriter/utility.h"
+
+/*
+ * Forward declarations.
+ */
+
+/*****************************************************************************
+ *
+ * Private functions.
+ *
+ ****************************************************************************/
+
+/*
+ * Create a new comment object.
+ */
+lxw_comment *
+lxw_comment_new()
+{
+    lxw_comment *comment = calloc(1, sizeof(lxw_comment));
+    GOTO_LABEL_ON_MEM_ERROR(comment, mem_error);
+
+    return comment;
+
+mem_error:
+    lxw_comment_free(comment);
+    return NULL;
+}
+
+/*
+ * Free a comment object.
+ */
+void
+lxw_comment_free(lxw_comment *comment)
+{
+    if (!comment)
+        return;
+
+    free(comment);
+}
+
+/*****************************************************************************
+ *
+ * XML functions.
+ *
+ ****************************************************************************/
+
+/*
+ * Write the XML declaration.
+ */
+STATIC void
+_comment_xml_declaration(lxw_comment *self)
+{
+    lxw_xml_declaration(self->file);
+}
+
+/*****************************************************************************
+ *
+ * XML file assembly functions.
+ *
+ ****************************************************************************/
+
+/*
+ * Write the <t> element.
+ */
+STATIC void
+_comment_write_text_t(lxw_comment *self, lxw_vml_obj *comment_obj)
+{
+    lxw_xml_data_element(self->file, "t", comment_obj->text, NULL);
+}
+
+/*
+ * Write the <family> element.
+ */
+STATIC void
+_comment_write_family(lxw_comment *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+    char val[] = "2";
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("val", val);
+
+    lxw_xml_empty_tag(self->file, "family", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <rFont> element.
+ */
+STATIC void
+_comment_write_r_font(lxw_comment *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+    char val[] = "Tahoma";
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("val", val);
+
+    lxw_xml_empty_tag(self->file, "rFont", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <color> element.
+ */
+STATIC void
+_comment_write_color(lxw_comment *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+    char indexed[] = "81";
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("indexed", indexed);
+
+    lxw_xml_empty_tag(self->file, "color", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <sz> element.
+ */
+STATIC void
+_comment_write_sz(lxw_comment *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+    char val[] = "8";
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("val", val);
+
+    lxw_xml_empty_tag(self->file, "sz", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <rPr> element.
+ */
+STATIC void
+_comment_write_r_pr(lxw_comment *self)
+{
+    lxw_xml_start_tag(self->file, "rPr", NULL);
+
+    /* Write the sz element. */
+    _comment_write_sz(self);
+
+    /* Write the color element. */
+    _comment_write_color(self);
+
+    /* Write the rFont element. */
+    _comment_write_r_font(self);
+
+    /* Write the family element. */
+    _comment_write_family(self);
+
+    lxw_xml_end_tag(self->file, "rPr");
+}
+
+/*
+ * Write the <r> element.
+ */
+STATIC void
+_comment_write_r(lxw_comment *self, lxw_vml_obj *comment_obj)
+{
+    lxw_xml_start_tag(self->file, "r", NULL);
+
+    /* Write the rPr element. */
+    _comment_write_r_pr(self);
+
+    /* Write the t element. */
+    _comment_write_text_t(self, comment_obj);
+
+    lxw_xml_end_tag(self->file, "r");
+}
+
+/*
+ * Write the <text> element.
+ */
+STATIC void
+_comment_write_text(lxw_comment *self, lxw_vml_obj *comment_obj)
+{
+    lxw_xml_start_tag(self->file, "text", NULL);
+
+    /* Write the r element. */
+    _comment_write_r(self, comment_obj);
+
+    lxw_xml_end_tag(self->file, "text");
+}
+
+/*
+ * Write the <comment> element.
+ */
+STATIC void
+_comment_write_comment(lxw_comment *self, lxw_vml_obj *comment_obj)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+    char ref[LXW_MAX_CELL_NAME_LENGTH];
+
+    lxw_rowcol_to_cell(ref, comment_obj->row, comment_obj->col);
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("ref", ref);
+    LXW_PUSH_ATTRIBUTES_INT("authorId", comment_obj->author_id);
+
+    lxw_xml_start_tag(self->file, "comment", &attributes);
+
+    /* Write the text element. */
+    _comment_write_text(self, comment_obj);
+
+    lxw_xml_end_tag(self->file, "comment");
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <commentList> element.
+ */
+STATIC void
+_comment_write_comment_list(lxw_comment *self)
+{
+    lxw_vml_obj *comment_obj;
+
+    lxw_xml_start_tag(self->file, "commentList", NULL);
+
+    STAILQ_FOREACH(comment_obj, self->comment_objs, list_pointers) {
+        /* Write the comment element. */
+        _comment_write_comment(self, comment_obj);
+    }
+
+    lxw_xml_end_tag(self->file, "commentList");
+
+}
+
+/*
+ * Write the <author> element.
+ */
+STATIC void
+_comment_write_author(lxw_comment *self)
+{
+    lxw_xml_data_element(self->file, "author", "John", NULL);
+}
+
+/*
+ * Write the <authors> element.
+ */
+STATIC void
+_comment_write_authors(lxw_comment *self)
+{
+    lxw_xml_start_tag(self->file, "authors", NULL);
+
+    /* Write the author element. */
+    _comment_write_author(self);
+
+    lxw_xml_end_tag(self->file, "authors");
+
+}
+
+/*
+ * Write the <comments> element.
+ */
+STATIC void
+_comment_write_comments(lxw_comment *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+    char xmlns[] =
+        "http://schemas.openxmlformats.org/spreadsheetml/2006/main";
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("xmlns", xmlns);
+
+    lxw_xml_start_tag(self->file, "comments", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Assemble and write the XML file.
+ */
+void
+lxw_comment_assemble_xml_file(lxw_comment *self)
+{
+    /* Write the XML declaration. */
+    _comment_xml_declaration(self);
+
+    /* Write the comments element. */
+    _comment_write_comments(self);
+
+    /* Write the authors element. */
+    _comment_write_authors(self);
+
+    /* Write the commentList element. */
+    _comment_write_comment_list(self);
+
+    lxw_xml_end_tag(self->file, "comments");
+}
+
+/*****************************************************************************
+ *
+ * Public functions.
+ *
+ ****************************************************************************/
diff --git a/src/content_types.c b/src/content_types.c
index fcbdf529..3bf3b238 100644
--- a/src/content_types.c
+++ b/src/content_types.c
@@ -322,6 +322,25 @@ lxw_ct_add_drawing_name(lxw_content_types *self, const char *name)
     lxw_ct_add_override(self, name, LXW_APP_DOCUMENT "drawing+xml");
 }
 
+/*
+ * Add the name of a VML drawing to the ContentTypes overrides.
+ */
+void
+lxw_ct_add_vml_name(lxw_content_types *self)
+{
+    lxw_ct_add_default(self, "vml", LXW_APP_DOCUMENT "vmlDrawing");
+}
+
+/*
+ * Add the name of a comment to the ContentTypes overrides.
+ */
+void
+lxw_ct_add_comment_name(lxw_content_types *self, const char *name)
+{
+    lxw_ct_add_override(self, name,
+                        LXW_APP_DOCUMENT "spreadsheetml.comments+xml");
+}
+
 /*
  * Add the sharedStrings link to the ContentTypes overrides.
  */
diff --git a/src/format.c b/src/format.c
index a52a23c2..fc905442 100644
--- a/src/format.c
+++ b/src/format.c
@@ -117,18 +117,6 @@ lxw_format_free(lxw_format *format)
     format = NULL;
 }
 
-/*
- * Check a user input color.
- */
-lxw_color_t
-lxw_format_check_colorz(lxw_color_t color)
-{
-    if (color == LXW_COLOR_UNSET)
-        return color;
-    else
-        return color & LXW_COLOR_MASK;
-}
-
 /*
  * Check a user input border.
  */
@@ -728,6 +716,24 @@ format_set_theme(lxw_format *self, uint8_t value)
     self->theme = value;
 }
 
+/*
+ * Set the color_indexed property.
+ */
+void
+format_set_color_indexed(lxw_format *self, uint8_t value)
+{
+    self->color_indexed = value;
+}
+
+/*
+ * Set the font_only property.
+ */
+void
+format_set_font_only(lxw_format *self)
+{
+    self->font_only = LXW_TRUE;
+}
+
 /*
  * Set the theme property.
  */
diff --git a/src/packager.c b/src/packager.c
index 6bfcaf1f..81bd2676 100644
--- a/src/packager.c
+++ b/src/packager.c
@@ -445,6 +445,106 @@ _get_drawing_count(lxw_packager *self)
     return drawing_count;
 }
 
+/*
+ * Write the comment/header VML files.
+ */
+STATIC lxw_error
+_write_vml_files(lxw_packager *self)
+{
+    lxw_workbook *workbook = self->workbook;
+    lxw_sheet *sheet;
+    lxw_worksheet *worksheet;
+    lxw_vml *vml;
+    char filename[LXW_FILENAME_LENGTH] = { 0 };
+    uint32_t index = 1;
+    lxw_error err;
+
+    STAILQ_FOREACH(sheet, workbook->sheets, list_pointers) {
+        if (sheet->is_chartsheet)
+            continue;
+        else
+            worksheet = sheet->u.worksheet;
+
+        if (!worksheet->has_vml)
+            continue;
+
+        vml = lxw_vml_new();
+        if (!vml)
+            return LXW_ERROR_MEMORY_MALLOC_FAILED;
+
+        lxw_snprintf(filename, LXW_FILENAME_LENGTH,
+                     "xl/drawings/vmlDrawing%d.vml", index++);
+
+        vml->file = lxw_tmpfile(self->tmpdir);
+        if (!vml->file)
+            return LXW_ERROR_CREATING_TMPFILE;
+
+        vml->comment_objs = worksheet->comment_objs;
+        vml->vml_shape_id = worksheet->vml_shape_id;
+
+        if (worksheet->vml_data_id_str)
+            vml->vml_data_id_str = worksheet->vml_data_id_str;
+        else
+            return LXW_ERROR_MEMORY_MALLOC_FAILED;
+
+        lxw_vml_assemble_xml_file(vml);
+
+        err = _add_file_to_zip(self, vml->file, filename);
+        RETURN_ON_ERROR(err);
+
+        fclose(vml->file);
+    }
+
+    return LXW_NO_ERROR;
+}
+
+/*
+ * Write the comment files.
+ */
+STATIC lxw_error
+_write_comment_files(lxw_packager *self)
+{
+    lxw_workbook *workbook = self->workbook;
+    lxw_sheet *sheet;
+    lxw_worksheet *worksheet;
+    lxw_comment *comment;
+    char filename[LXW_FILENAME_LENGTH] = { 0 };
+    uint32_t index = 1;
+    lxw_error err;
+
+    STAILQ_FOREACH(sheet, workbook->sheets, list_pointers) {
+        if (sheet->is_chartsheet)
+            continue;
+        else
+            worksheet = sheet->u.worksheet;
+
+        if (!worksheet->has_comments)
+            continue;
+
+        comment = lxw_comment_new();
+        if (!comment)
+            return LXW_ERROR_MEMORY_MALLOC_FAILED;
+
+        lxw_snprintf(filename, LXW_FILENAME_LENGTH,
+                     "xl/comments%d.xml", index++);
+
+        comment->file = lxw_tmpfile(self->tmpdir);
+        if (!comment->file)
+            return LXW_ERROR_CREATING_TMPFILE;
+
+        comment->comment_objs = worksheet->comment_objs;
+
+        lxw_comment_assemble_xml_file(comment);
+
+        err = _add_file_to_zip(self, comment->file, filename);
+        RETURN_ON_ERROR(err);
+
+        fclose(comment->file);
+    }
+
+    return LXW_NO_ERROR;
+}
+
 /*
  * Write the sharedStrings.xml file.
  */
@@ -792,6 +892,15 @@ _write_content_types_file(lxw_packager *self)
         lxw_ct_add_drawing_name(content_types, filename);
     }
 
+    if (workbook->has_vml)
+        lxw_ct_add_vml_name(content_types);
+
+    for (index = 1; index <= workbook->comment_count; index++) {
+        lxw_snprintf(filename, LXW_FILENAME_LENGTH,
+                     "/xl/comments%d.xml", index);
+        lxw_ct_add_comment_name(content_types, filename);
+    }
+
     if (workbook->sst->string_count)
         lxw_ct_add_shared_strings(content_types);
 
@@ -898,7 +1007,9 @@ _write_worksheet_rels_file(lxw_packager *self)
         index++;
 
         if (STAILQ_EMPTY(worksheet->external_hyperlinks) &&
-            STAILQ_EMPTY(worksheet->external_drawing_links))
+            STAILQ_EMPTY(worksheet->external_drawing_links) &&
+            !worksheet->external_vml_comment_link &&
+            !worksheet->external_comment_link)
             continue;
 
         rels = lxw_relationships_new();
@@ -919,6 +1030,16 @@ _write_worksheet_rels_file(lxw_packager *self)
                                            rel->target_mode);
         }
 
+        rel = worksheet->external_vml_comment_link;
+        if (rel)
+            lxw_add_worksheet_relationship(rels, rel->type, rel->target,
+                                           rel->target_mode);
+
+        rel = worksheet->external_comment_link;
+        if (rel)
+            lxw_add_worksheet_relationship(rels, rel->type, rel->target,
+                                           rel->target_mode);
+
         lxw_snprintf(sheetname, LXW_FILENAME_LENGTH,
                      "xl/worksheets/_rels/sheet%d.xml.rels", index);
 
@@ -1228,6 +1349,12 @@ lxw_create_package(lxw_packager *self)
     error = _write_drawing_files(self);
     RETURN_ON_ERROR(error);
 
+    error = _write_vml_files(self);
+    RETURN_ON_ERROR(error);
+
+    error = _write_comment_files(self);
+    RETURN_ON_ERROR(error);
+
     error = _write_shared_strings_file(self);
     RETURN_ON_ERROR(error);
 
diff --git a/src/styles.c b/src/styles.c
index 84efc867..61095b48 100644
--- a/src/styles.c
+++ b/src/styles.c
@@ -240,6 +240,23 @@ _write_font_color_rgb(lxw_styles *self, int32_t rgb)
     LXW_FREE_ATTRIBUTES();
 }
 
+/*
+ * Write the <color> element for indexed colors.
+ */
+STATIC void
+_write_font_color_indexed(lxw_styles *self, uint8_t index)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_INT("indexed", index);
+
+    lxw_xml_empty_tag(self->file, "color", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
 /*
  * Write the <name> element.
  */
@@ -386,6 +403,8 @@ _write_font(lxw_styles *self, lxw_format *format, uint8_t is_rich_string)
 
     if (format->theme)
         _write_font_color_theme(self, format->theme);
+    else if (format->color_indexed)
+        _write_font_color_indexed(self, format->color_indexed);
     else if (format->font_color != LXW_COLOR_UNSET)
         _write_font_color_rgb(self, format->font_color);
     else
@@ -1051,14 +1070,27 @@ _write_cell_xfs(lxw_styles *self)
     struct xml_attribute_list attributes;
     struct xml_attribute *attribute;
     lxw_format *format;
+    uint32_t count = self->xf_count;
+    uint32_t i = 0;
+
+    /* If the last format is "font_only" it is for the comment font and
+     * shouldn't be counted. This is a workaround to get the last object
+     * in the list since STAILQ_LAST() requires __containerof and isn't
+     * ANSI compatible. */
+    STAILQ_FOREACH(format, self->xf_formats, list_pointers) {
+        i++;
+        if (i == self->xf_count && format->font_only)
+            count--;
+    }
 
     LXW_INIT_ATTRIBUTES();
-    LXW_PUSH_ATTRIBUTES_INT("count", self->xf_count);
+    LXW_PUSH_ATTRIBUTES_INT("count", count);
 
     lxw_xml_start_tag(self->file, "cellXfs", &attributes);
 
     STAILQ_FOREACH(format, self->xf_formats, list_pointers) {
-        _write_xf(self, format);
+        if (!format->font_only)
+            _write_xf(self, format);
     }
 
     lxw_xml_end_tag(self->file, "cellXfs");
diff --git a/src/utility.c b/src/utility.c
index 564acc11..e2ce5c1e 100644
--- a/src/utility.c
+++ b/src/utility.c
@@ -27,6 +27,7 @@ char *error_strings[LXW_MAX_ERRNO + 1] = {
     "Zip error ZIP_INTERNALERROR while creating the xlsx file.",
     "File error or unknown zip error when adding sub file to xlsx file.",
     "Unknown zip error when closing xlsx file.",
+    "Feature is not currently supported in this configuration.",
     "NULL function parameter ignored.",
     "Function parameter validation error.",
     "Worksheet name exceeds Excel's limit of 31 characters.",
diff --git a/src/vml.c b/src/vml.c
new file mode 100644
index 00000000..dcb52bf4
--- /dev/null
+++ b/src/vml.c
@@ -0,0 +1,980 @@
+/*****************************************************************************
+ * vml - A library for creating Excel XLSX vml files.
+ *
+ * Used in conjunction with the libxlsxwriter library.
+ *
+ * Copyright 2014-2019, John McNamara, jmcnamara@cpan.org. See LICENSE.txt.
+ *
+ */
+
+#include "xlsxwriter/xmlwriter.h"
+#include "xlsxwriter/vml.h"
+#include "xlsxwriter/utility.h"
+
+/*
+ * Forward declarations.
+ */
+
+/*****************************************************************************
+ *
+ * Private functions.
+ *
+ ****************************************************************************/
+
+/*
+ * Create a new vml object.
+ */
+lxw_vml *
+lxw_vml_new()
+{
+    lxw_vml *vml = calloc(1, sizeof(lxw_vml));
+    GOTO_LABEL_ON_MEM_ERROR(vml, mem_error);
+
+    return vml;
+
+mem_error:
+    lxw_vml_free(vml);
+    return NULL;
+}
+
+/*
+ * Free a vml object.
+ */
+void
+lxw_vml_free(lxw_vml *vml)
+{
+    if (!vml)
+        return;
+
+    free(vml);
+}
+
+/*****************************************************************************
+ *
+ * XML functions.
+ *
+ ****************************************************************************/
+
+/*
+ * Write the <v:f> element.
+ */
+STATIC void
+_vml_write_formula(lxw_vml *self, char *equation)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("eqn", equation);
+
+    lxw_xml_empty_tag(self->file, "v:f", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <v:formulas> element.
+ */
+STATIC void
+_vml_write_formulas(lxw_vml *self)
+{
+    lxw_xml_start_tag(self->file, "v:formulas", NULL);
+
+    _vml_write_formula(self, "if lineDrawn pixelLineWidth 0");
+    _vml_write_formula(self, "sum @0 1 0");
+    _vml_write_formula(self, "sum 0 0 @1");
+    _vml_write_formula(self, "prod @2 1 2");
+    _vml_write_formula(self, "prod @3 21600 pixelWidth");
+    _vml_write_formula(self, "prod @3 21600 pixelHeight");
+    _vml_write_formula(self, "sum @0 0 1");
+    _vml_write_formula(self, "prod @6 1 2");
+    _vml_write_formula(self, "prod @7 21600 pixelWidth");
+    _vml_write_formula(self, "sum @8 21600 0");
+    _vml_write_formula(self, "prod @7 21600 pixelHeight");
+    _vml_write_formula(self, "sum @10 21600 0");
+
+    lxw_xml_end_tag(self->file, "v:formulas");
+}
+
+/*
+ * Write the <x:TextHAlign> element.
+ */
+STATIC void
+_vml_write_text_halign(lxw_vml *self)
+{
+
+    lxw_xml_data_element(self->file, "x:TextHAlign", "Center", NULL);
+}
+
+/*
+ * Write the <x:TextVAlign> element.
+ */
+STATIC void
+_vml_write_text_valign(lxw_vml *self)
+{
+    lxw_xml_data_element(self->file, "x:TextVAlign", "Center", NULL);
+}
+
+/*
+ * Write the <x:FmlaMacro> element.
+ */
+STATIC void
+_vml_write_fmla_macro(lxw_vml *self)
+{
+    lxw_xml_data_element(self->file, "x:FmlaMacro", "[0]!Button1_Click",
+                         NULL);
+}
+
+/*
+ * Write the <x:PrintObject> element.
+ */
+STATIC void
+_vml_write_print_object(lxw_vml *self)
+{
+    lxw_xml_data_element(self->file, "x:PrintObject", "False", NULL);
+}
+
+/*
+ * Write the <o:lock> element.
+ */
+STATIC void
+_vml_write_aspect_ratio_lock(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("v:ext", "edit");
+    LXW_PUSH_ATTRIBUTES_STR("aspectratio", "t");
+
+    lxw_xml_empty_tag(self->file, "o:lock", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <o:lock> element.
+ */
+STATIC void
+_vml_write_rotation_lock(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("v:ext", "edit");
+    LXW_PUSH_ATTRIBUTES_STR("rotation", "t");
+
+    lxw_xml_empty_tag(self->file, "o:lock", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <x:Column> element.
+ */
+STATIC void
+_vml_write_column(lxw_vml *self, lxw_vml_obj *comment_obj)
+{
+    char data[LXW_ATTR_32];
+
+    lxw_snprintf(data, LXW_ATTR_32, "%d", comment_obj->col);
+
+    lxw_xml_data_element(self->file, "x:Column", data, NULL);
+}
+
+/*
+ * Write the <x:Row> element.
+ */
+STATIC void
+_vml_write_row(lxw_vml *self, lxw_vml_obj *comment_obj)
+{
+    char data[LXW_ATTR_32];
+
+    lxw_snprintf(data, LXW_ATTR_32, "%d", comment_obj->row);
+
+    lxw_xml_data_element(self->file, "x:Row", data, NULL);
+}
+
+/*
+ * Write the <x:AutoFill> element.
+ */
+STATIC void
+_vml_write_auto_fill(lxw_vml *self)
+{
+    lxw_xml_data_element(self->file, "x:AutoFill", "False", NULL);
+}
+
+/*
+ * Write the <x:Anchor> element.
+ */
+STATIC void
+_vml_write_anchor(lxw_vml *self, lxw_vml_obj *comment_obj)
+{
+    char anchor_data[LXW_MAX_ATTRIBUTE_LENGTH];
+
+    lxw_snprintf(anchor_data,
+                 LXW_MAX_ATTRIBUTE_LENGTH,
+                 "%d, %d, %d, %d, %d, %d, %d, %d",
+                 comment_obj->from.col,
+                 (uint32_t) comment_obj->from.col_offset,
+                 comment_obj->from.row,
+                 (uint32_t) comment_obj->from.row_offset,
+                 comment_obj->to.col,
+                 (uint32_t) comment_obj->to.col_offset,
+                 comment_obj->to.row, (uint32_t) comment_obj->to.row_offset);
+
+    lxw_xml_data_element(self->file, "x:Anchor", anchor_data, NULL);
+}
+
+/*
+ * Write the <x:SizeWithCells> element.
+ */
+STATIC void
+_vml_write_size_with_cells(lxw_vml *self)
+{
+    lxw_xml_empty_tag(self->file, "x:SizeWithCells", NULL);
+}
+
+/*
+ * Write the <x:MoveWithCells> element.
+ */
+STATIC void
+_vml_write_move_with_cells(lxw_vml *self)
+{
+    lxw_xml_empty_tag(self->file, "x:MoveWithCells", NULL);
+}
+
+/*
+ * Write the <v:shadow> element.
+ */
+STATIC void
+_vml_write_shadow(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("on", "t");
+    LXW_PUSH_ATTRIBUTES_STR("color", "black");
+    LXW_PUSH_ATTRIBUTES_STR("obscured", "t");
+
+    lxw_xml_empty_tag(self->file, "v:shadow", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <v:stroke> element.
+ */
+STATIC void
+_vml_write_stroke(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("joinstyle", "miter");
+
+    lxw_xml_empty_tag(self->file, "v:stroke", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <o:lock> element.
+ */
+STATIC void
+_vml_write_shapetype_lock(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("v:ext", "edit");
+    LXW_PUSH_ATTRIBUTES_STR("shapetype", "t");
+
+    lxw_xml_empty_tag(self->file, "o:lock", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <font> element.
+ */
+STATIC void
+_vml_write_font(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("face", "Calibri");
+    LXW_PUSH_ATTRIBUTES_STR("size", "220");
+    LXW_PUSH_ATTRIBUTES_STR("color", "#000000");
+
+    lxw_xml_data_element(self->file, "font", "Button 1", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <v:imagedata> element.
+ */
+STATIC void
+_vml_write_imagedata(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+    char rel_id[] = "rId1";
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("o:relid", rel_id);
+    LXW_PUSH_ATTRIBUTES_STR("o:title", "red");
+
+    lxw_xml_empty_tag(self->file, "v:imagedata", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <v:path> element.
+ */
+STATIC void
+_vml_write_image_path(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("o:extrusionok", "f");
+    LXW_PUSH_ATTRIBUTES_STR("gradientshapeok", "t");
+    LXW_PUSH_ATTRIBUTES_STR("o:connecttype", "rect");
+
+    lxw_xml_empty_tag(self->file, "v:path", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <v:shape> element.
+ */
+STATIC void
+_vml_write_image_shape(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+    char id[] = "CH";
+    char o_spid[] = "_x0000_s1025";
+    char type[] = "#_x0000_t75";
+    char style[] = "position:absolute;margin-left:0;margin-top:0;width:24pt;"
+        "height:24pt;z-index:1";
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("id", id);
+    LXW_PUSH_ATTRIBUTES_STR("o:spid", o_spid);
+    LXW_PUSH_ATTRIBUTES_STR("type", type);
+    LXW_PUSH_ATTRIBUTES_STR("style", style);
+
+    lxw_xml_start_tag(self->file, "v:shape", &attributes);
+
+    /* Write the v:imagedata element. */
+    _vml_write_imagedata(self);
+
+    /* Write the o:lock element. */
+    _vml_write_rotation_lock(self);
+
+    lxw_xml_end_tag(self->file, "v:shape");
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <v:shapetype> element for images..
+ */
+STATIC void
+_vml_write_image_shapetype(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+    char id[] = "_x0000_t75";
+    char coordsize[] = "21600,21600";
+    char o_spt[] = "75";
+    char o_preferrelative[] = "t";
+    char path[] = "m@4@5l@4@11@9@11@9@5xe";
+    char filled[] = "f";
+    char stroked[] = "f";
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("id", id);
+    LXW_PUSH_ATTRIBUTES_STR("coordsize", coordsize);
+    LXW_PUSH_ATTRIBUTES_STR("o:spt", o_spt);
+    LXW_PUSH_ATTRIBUTES_STR("o:preferrelative", o_preferrelative);
+    LXW_PUSH_ATTRIBUTES_STR("path", path);
+    LXW_PUSH_ATTRIBUTES_STR("filled", filled);
+    LXW_PUSH_ATTRIBUTES_STR("stroked", stroked);
+
+    lxw_xml_start_tag(self->file, "v:shapetype", &attributes);
+
+    /* Write the v:stroke element. */
+    _vml_write_stroke(self);
+
+    /* Write the v:formulas element. */
+    _vml_write_formulas(self);
+
+    /* Write the v:path element. */
+    _vml_write_image_path(self);
+
+    /* Write the o:lock element. */
+    _vml_write_aspect_ratio_lock(self);
+
+    lxw_xml_end_tag(self->file, "v:shapetype");
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <x:ClientData> element.
+ */
+STATIC void
+_vml_write_button_client_data(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("ObjectType", "Button");
+
+    lxw_xml_start_tag(self->file, "x:ClientData", &attributes);
+
+    /* Write the <x:Anchor> element. */
+    _vml_write_anchor(self, NULL);
+
+    /* Write the x:PrintObject element. */
+    _vml_write_print_object(self);
+
+    /* Write the x:AutoFill element. */
+    _vml_write_auto_fill(self);
+
+    /* Write the x:FmlaMacro element. */
+    _vml_write_fmla_macro(self);
+
+    /* Write the x:TextHAlign element. */
+    _vml_write_text_halign(self);
+
+    /* Write the x:TextVAlign element. */
+    _vml_write_text_valign(self);
+
+    lxw_xml_end_tag(self->file, "x:ClientData");
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <div> element.
+ */
+STATIC void
+_vml_write_button_div(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("style", "text-align:center");
+
+    lxw_xml_start_tag(self->file, "div", &attributes);
+
+    /* Write the font element. */
+    _vml_write_font(self);
+
+    lxw_xml_end_tag(self->file, "div");
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <v:textbox> element.
+ */
+STATIC void
+_vml_write_button_textbox(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("style", "mso-direction-alt:auto");
+    LXW_PUSH_ATTRIBUTES_STR("o:singleclick", "f");
+
+    lxw_xml_start_tag(self->file, "v:textbox", &attributes);
+
+    /* Write the div element. */
+    _vml_write_button_div(self);
+
+    lxw_xml_end_tag(self->file, "v:textbox");
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <v:fill> element.
+ */
+STATIC void
+_vml_write_button_fill(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("color2", "buttonFace [67]");
+    LXW_PUSH_ATTRIBUTES_STR("o:detectmouseclick", "t");
+
+    lxw_xml_empty_tag(self->file, "v:fill", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <v:path> element for buttons.
+ */
+STATIC void
+_vml_write_button_path(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("shadowok", "f");
+    LXW_PUSH_ATTRIBUTES_STR("o:extrusionok", "f");
+    LXW_PUSH_ATTRIBUTES_STR("strokeok", "f");
+    LXW_PUSH_ATTRIBUTES_STR("fillok", "f");
+    LXW_PUSH_ATTRIBUTES_STR("o:connecttype", "rect");
+
+    lxw_xml_empty_tag(self->file, "v:path", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <v:shape> element for buttons.
+ */
+STATIC void
+_vml_write_button_shape(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+    char id[] = "_x0000_s1025";
+    char type[] = "#_x0000_t201";
+    char style[] = "position:absolute;margin-left:96pt;margin-top:15pt;"
+        "width:48pt;height:15pt;z-index:1;mso-wrap-style:tight";
+    char o_button[] = "t";
+    char fillcolor[] = "buttonFace [67]";
+    char strokecolor[] = "windowText [64]";
+    char o_insetmode[] = "auto";
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("id", id);
+    LXW_PUSH_ATTRIBUTES_STR("type", type);
+    LXW_PUSH_ATTRIBUTES_STR("style", style);
+    LXW_PUSH_ATTRIBUTES_STR("o:button", o_button);
+    LXW_PUSH_ATTRIBUTES_STR("fillcolor", fillcolor);
+    LXW_PUSH_ATTRIBUTES_STR("strokecolor", strokecolor);
+    LXW_PUSH_ATTRIBUTES_STR("o:insetmode", o_insetmode);
+
+    lxw_xml_start_tag(self->file, "v:shape", &attributes);
+
+    /* Write the v:fill element. */
+    _vml_write_button_fill(self);
+
+    /* Write the o:lock element. */
+    _vml_write_rotation_lock(self);
+
+    /* Write the v:textbox element. */
+    _vml_write_button_textbox(self);
+
+    /* Write the x:ClientData element. */
+    _vml_write_button_client_data(self);
+
+    lxw_xml_end_tag(self->file, "v:shape");
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <v:shapetype> element for buttons.
+ */
+STATIC void
+_vml_write_button_shapetype(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+    char id[] = "_x0000_t201";
+    char coordsize[] = "21600,21600";
+    char o_spt[] = "201";
+    char path[] = "m,l,21600r21600,l21600,xe";
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("id", id);
+    LXW_PUSH_ATTRIBUTES_STR("coordsize", coordsize);
+    LXW_PUSH_ATTRIBUTES_STR("o:spt", o_spt);
+    LXW_PUSH_ATTRIBUTES_STR("path", path);
+
+    lxw_xml_start_tag(self->file, "v:shapetype", &attributes);
+
+    /* Write the v:stroke element. */
+    _vml_write_stroke(self);
+
+    /* Write the v:path element. */
+    _vml_write_button_path(self);
+
+    /* Write the o:lock element. */
+    _vml_write_shapetype_lock(self);
+
+    lxw_xml_end_tag(self->file, "v:shapetype");
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <x:ClientData> element.
+ */
+STATIC void
+_vml_write_comment_client_data(lxw_vml *self, lxw_vml_obj *comment_obj)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("ObjectType", "Note");
+
+    lxw_xml_start_tag(self->file, "x:ClientData", &attributes);
+
+    /* Write the <x:MoveWithCells> element. */
+    _vml_write_move_with_cells(self);
+
+    /* Write the <x:SizeWithCells> element. */
+    _vml_write_size_with_cells(self);
+
+    /* Write the <x:Anchor> element. */
+    _vml_write_anchor(self, comment_obj);
+
+    /* Write the <x:AutoFill> element. */
+    _vml_write_auto_fill(self);
+
+    /* Write the <x:Row> element. */
+    _vml_write_row(self, comment_obj);
+
+    /* Write the <x:Column> element. */
+    _vml_write_column(self, comment_obj);
+
+    lxw_xml_end_tag(self->file, "x:ClientData");
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <div> element.
+ */
+STATIC void
+_vml_write_comment_div(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("style", "text-align:left");
+
+    lxw_xml_start_tag(self->file, "div", &attributes);
+
+    lxw_xml_end_tag(self->file, "div");
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <v:textbox> element.
+ */
+STATIC void
+_vml_write_comment_textbox(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("style", "mso-direction-alt:auto");
+
+    lxw_xml_start_tag(self->file, "v:textbox", &attributes);
+
+    /* Write the div element. */
+    _vml_write_comment_div(self);
+
+    lxw_xml_end_tag(self->file, "v:textbox");
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <v:fill> element.
+ */
+STATIC void
+_vml_write_comment_fill(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("color2", "#ffffe1");
+
+    lxw_xml_empty_tag(self->file, "v:fill", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <v:path> element.
+ */
+STATIC void
+_vml_write_comment_path(lxw_vml *self, uint8_t has_gradient, char *type)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+
+    if (has_gradient)
+        LXW_PUSH_ATTRIBUTES_STR("gradientshapeok", "t");
+
+    LXW_PUSH_ATTRIBUTES_STR("o:connecttype", type);
+
+    lxw_xml_empty_tag(self->file, "v:path", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <v:shape> element for comments.
+ */
+STATIC void
+_vml_write_comment_shape(lxw_vml *self, uint32_t vml_shape_id,
+                         uint32_t z_index, lxw_vml_obj *comment_obj)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+    char id[LXW_ATTR_32];
+    char margin_left[LXW_ATTR_32];
+    char margin_top[LXW_ATTR_32];
+    char width[LXW_ATTR_32];
+    char height[LXW_ATTR_32];
+    char style[LXW_MAX_ATTRIBUTE_LENGTH];
+    char type[] = "#_x0000_t202";
+    char fillcolor[] = "#ffffe1";
+    char o_insetmode[] = "auto";
+
+    lxw_sprintf_dbl(margin_left, comment_obj->col_absolute * 0.75);
+    lxw_sprintf_dbl(margin_top, comment_obj->row_absolute * 0.75);
+    lxw_sprintf_dbl(width, comment_obj->width * 0.75);
+    lxw_sprintf_dbl(height, comment_obj->height * 0.75);
+
+    lxw_snprintf(id, LXW_ATTR_32, "_x0000_s%d", vml_shape_id);
+
+    lxw_snprintf(style,
+                 LXW_MAX_ATTRIBUTE_LENGTH,
+                 "position:absolute;"
+                 "margin-left:%spt;"
+                 "margin-top:%spt;"
+                 "width:%spt;"
+                 "height:%spt;"
+                 "z-index:%d;"
+                 "visibility:hidden",
+                 margin_left, margin_top, width, height, z_index);
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("id", id);
+    LXW_PUSH_ATTRIBUTES_STR("type", type);
+    LXW_PUSH_ATTRIBUTES_STR("style", style);
+    LXW_PUSH_ATTRIBUTES_STR("fillcolor", fillcolor);
+    LXW_PUSH_ATTRIBUTES_STR("o:insetmode", o_insetmode);
+
+    lxw_xml_start_tag(self->file, "v:shape", &attributes);
+
+    /* Write the v:fill element. */
+    _vml_write_comment_fill(self);
+
+    /* Write the v:shadow element. */
+    _vml_write_shadow(self);
+
+    /* Write the v:path element. */
+    _vml_write_comment_path(self, LXW_FALSE, "none");
+
+    /* Write the v:textbox element. */
+    _vml_write_comment_textbox(self);
+
+    /* Write the x:ClientData element. */
+    _vml_write_comment_client_data(self, comment_obj);
+
+    lxw_xml_end_tag(self->file, "v:shape");
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <v:shapetype> element for comments.
+ */
+STATIC void
+_vml_write_comment_shapetype(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+    char id[] = "_x0000_t202";
+    char coordsize[] = "21600,21600";
+    char o_spt[] = "202";
+    char path[] = "m,l,21600r21600,l21600,xe";
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("id", id);
+    LXW_PUSH_ATTRIBUTES_STR("coordsize", coordsize);
+    LXW_PUSH_ATTRIBUTES_STR("o:spt", o_spt);
+    LXW_PUSH_ATTRIBUTES_STR("path", path);
+
+    lxw_xml_start_tag(self->file, "v:shapetype", &attributes);
+
+    /* Write the v:stroke element. */
+    _vml_write_stroke(self);
+
+    /* Write the v:path element. */
+    _vml_write_comment_path(self, LXW_TRUE, "rect");
+
+    lxw_xml_end_tag(self->file, "v:shapetype");
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <o:idmap> element.
+ */
+STATIC void
+_vml_write_idmap(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("v:ext", "edit");
+    LXW_PUSH_ATTRIBUTES_STR("data", self->vml_data_id_str);
+
+    lxw_xml_empty_tag(self->file, "o:idmap", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <o:shapelayout> element.
+ */
+STATIC void
+_vml_write_shapelayout(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("v:ext", "edit");
+
+    lxw_xml_start_tag(self->file, "o:shapelayout", &attributes);
+
+    /* Write the o:idmap element. */
+    _vml_write_idmap(self);
+
+    lxw_xml_end_tag(self->file, "o:shapelayout");
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*
+ * Write the <xml> element.
+ */
+STATIC void
+_vml_write_xml_namespace(lxw_vml *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+    char xmlns_v[] = "urn:schemas-microsoft-com:vml";
+    char xmlns_o[] = "urn:schemas-microsoft-com:office:office";
+    char xmlns_x[] = "urn:schemas-microsoft-com:office:excel";
+
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("xmlns:v", xmlns_v);
+    LXW_PUSH_ATTRIBUTES_STR("xmlns:o", xmlns_o);
+    LXW_PUSH_ATTRIBUTES_STR("xmlns:x", xmlns_x);
+
+    lxw_xml_start_tag(self->file, "xml", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+}
+
+/*****************************************************************************
+ *
+ * XML file assembly functions.
+ *
+ ****************************************************************************/
+
+/*
+ * Assemble and write the XML file.
+ */
+void
+lxw_vml_assemble_xml_file(lxw_vml *self)
+{
+    lxw_vml_obj *comment_obj;
+    lxw_vml_obj *button_obj;
+    lxw_vml_obj *image_obj;
+    uint32_t z_index = 1;
+
+    /* Write the xml namespace element. Note, the VML files have no
+     * XML declaration.*/
+    _vml_write_xml_namespace(self);
+
+    /* Write the o:shapelayout element. */
+    _vml_write_shapelayout(self);
+
+    if (self->comment_objs) {
+        /* Write the <v:shapetype> element. */
+        _vml_write_comment_shapetype(self);
+
+        STAILQ_FOREACH(comment_obj, self->comment_objs, list_pointers) {
+            self->vml_shape_id += 1;
+
+            /* Write the <v:shape> element. */
+            _vml_write_comment_shape(self, self->vml_shape_id, z_index,
+                                     comment_obj);
+
+            z_index += 1;
+        }
+    }
+
+    if (self->button_objs) {
+        /* Write the <v:shapetype> element. */
+        _vml_write_button_shapetype(self);
+
+        STAILQ_FOREACH(button_obj, self->button_objs, list_pointers) {
+            /* Write the <v:shape> element. */
+            _vml_write_button_shape(self);
+
+        }
+    }
+
+    if (self->image_objs) {
+        /* Write the <v:shapetype> element. */
+        _vml_write_image_shapetype(self);
+
+        STAILQ_FOREACH(image_obj, self->image_objs, list_pointers) {
+            /* Write the <v:shape> element. */
+            _vml_write_image_shape(self);
+        }
+    }
+
+    lxw_xml_end_tag(self->file, "xml");
+}
+
+/*****************************************************************************
+ *
+ * Public functions.
+ *
+ ****************************************************************************/
diff --git a/src/workbook.c b/src/workbook.c
index d49d759d..f3b357aa 100644
--- a/src/workbook.c
+++ b/src/workbook.c
@@ -767,7 +767,7 @@ _populate_range_data_cache(lxw_workbook *self, lxw_series_range *range)
                 return;
             }
 
-            cell_obj = lxw_worksheet_find_cell(row_obj, col_num);
+            cell_obj = lxw_worksheet_find_cell_in_row(row_obj, col_num);
 
             if (cell_obj) {
                 if (cell_obj->type == NUMBER_CELL) {
@@ -1000,6 +1000,66 @@ _prepare_drawings(lxw_workbook *self)
     self->drawing_count = drawing_id;
 }
 
+/*
+ * Iterate through the worksheets and set up the VML objects.
+ */
+
+STATIC void
+_prepare_vml(lxw_workbook *self)
+{
+    lxw_worksheet *worksheet;
+    lxw_sheet *sheet;
+    uint32_t comment_id = 0;
+    uint32_t vml_drawing_id = 0;
+    uint32_t vml_data_id = 1;
+    uint32_t vml_shape_id = 1024;
+    lxw_format *format;
+    uint32_t comment_count = 0;
+
+    STAILQ_FOREACH(sheet, self->sheets, list_pointers) {
+        if (sheet->is_chartsheet)
+            continue;
+        else
+            worksheet = sheet->u.worksheet;
+
+        if (!worksheet->has_vml && !worksheet->has_header_vml)
+            continue;
+
+        if (worksheet->has_vml) {
+            self->has_vml = LXW_TRUE;
+            if (worksheet->has_comments) {
+                self->comment_count += 1;
+                comment_id += 1;
+            }
+
+            vml_drawing_id += 1;
+
+            comment_count = lxw_worksheet_prepare_vml_objects(worksheet,
+                                                              vml_data_id,
+                                                              vml_shape_id,
+                                                              vml_drawing_id,
+                                                              comment_id);
+
+            /* Each VML should start with a shape id incremented by 1024. */
+            vml_data_id += 1 * ((1024 + comment_count) / 1024);
+            vml_shape_id += 1024 * ((1024 + comment_count) / 1024);
+
+        }
+    }
+
+    if (self->comment_count) {
+        /* Add a font format for cell comments. */
+        format = workbook_add_format(self);
+        format_set_font_name(format, "Tahoma");
+        format_set_font_size(format, 8);
+        format_set_color_indexed(format, 81);
+        format_set_font_only(format);
+        /* Initialize its index. */
+        lxw_format_get_xf_index(format);
+    }
+
+}
+
 /*
  * Iterate through the worksheets and store any defined names used for print
  * ranges or repeat rows/columns.
@@ -1821,6 +1881,9 @@ workbook_close(lxw_workbook *self)
         }
     }
 
+    /* Prepare the worksheet VML elements such as comments. */
+    _prepare_vml(self);
+
     /* Set the defined names for the worksheets such as Print Titles. */
     _prepare_defined_names(self);
 
@@ -2250,8 +2313,6 @@ workbook_unset_default_url_format(lxw_workbook *self)
     self->default_url_format->theme = 0;
 }
 
-lxw_format *default_url_format;
-
 /*
  * Validate the worksheet name based on Excel's rules.
  */
diff --git a/src/worksheet.c b/src/worksheet.c
index 04f6bc18..cf7f2440 100644
--- a/src/worksheet.c
+++ b/src/worksheet.c
@@ -11,7 +11,6 @@
 #include "xlsxwriter/worksheet.h"
 #include "xlsxwriter/format.h"
 #include "xlsxwriter/utility.h"
-#include "xlsxwriter/relationships.h"
 #include "xlsxwriter/third_party/md5.h"
 
 #define LXW_STR_MAX                      32767
@@ -48,27 +47,27 @@ LXW_RB_GENERATE_DRAWING_REL_IDS(lxw_drawing_rel_ids, lxw_drawing_rel_id,
 lxw_row *
 lxw_worksheet_find_row(lxw_worksheet *self, lxw_row_t row_num)
 {
-    lxw_row row;
+    lxw_row tmp_row;
 
-    row.row_num = row_num;
+    tmp_row.row_num = row_num;
 
-    return RB_FIND(lxw_table_rows, self->table, &row);
+    return RB_FIND(lxw_table_rows, self->table, &tmp_row);
 }
 
 /*
  * Find but don't create a cell object for a given row object and col number.
  */
 lxw_cell *
-lxw_worksheet_find_cell(lxw_row *row, lxw_col_t col_num)
+lxw_worksheet_find_cell_in_row(lxw_row *row, lxw_col_t col_num)
 {
-    lxw_cell cell;
+    lxw_cell tmp_cell;
 
     if (!row)
         return NULL;
 
-    cell.col_num = col_num;
+    tmp_cell.col_num = col_num;
 
-    return RB_FIND(lxw_table_cells, row->cells, &cell);
+    return RB_FIND(lxw_table_cells, row->cells, &tmp_cell);
 }
 
 /*
@@ -122,6 +121,10 @@ lxw_worksheet_new(lxw_worksheet_init_data *init_data)
     GOTO_LABEL_ON_MEM_ERROR(worksheet->chart_data, mem_error);
     STAILQ_INIT(worksheet->chart_data);
 
+    worksheet->comment_objs = calloc(1, sizeof(struct lxw_comment_objs));
+    GOTO_LABEL_ON_MEM_ERROR(worksheet->comment_objs, mem_error);
+    STAILQ_INIT(worksheet->comment_objs);
+
     worksheet->selections = calloc(1, sizeof(struct lxw_selections));
     GOTO_LABEL_ON_MEM_ERROR(worksheet->selections, mem_error);
     STAILQ_INIT(worksheet->selections);
@@ -227,6 +230,23 @@ lxw_worksheet_new(lxw_worksheet_init_data *init_data)
     return NULL;
 }
 
+/*
+ * Free a worksheet data_validation.
+ */
+STATIC void
+_free_vml_object(lxw_vml_obj *vml_obj)
+{
+    if (!vml_obj)
+        return;
+
+    free(vml_obj->author);
+    free(vml_obj->font_name);
+    free(vml_obj->font_family);
+    free(vml_obj->text);
+
+    free(vml_obj);
+}
+
 /*
  * Free a worksheet cell.
  */
@@ -245,6 +265,8 @@ _free_cell(lxw_cell *cell)
     free(cell->user_data1);
     free(cell->user_data2);
 
+    _free_vml_object(cell->comment);
+
     free(cell);
 }
 
@@ -394,6 +416,9 @@ lxw_worksheet_free(lxw_worksheet *worksheet)
         free(worksheet->chart_data);
     }
 
+    /* Just free the list. The list objects are free elsewhere. */
+    free(worksheet->comment_objs);
+
     if (worksheet->selections) {
         while (!STAILQ_EMPTY(worksheet->selections)) {
             selection = STAILQ_FIRST(worksheet->selections);
@@ -479,6 +504,7 @@ lxw_worksheet_free(lxw_worksheet *worksheet)
     free(worksheet->name);
     free(worksheet->quoted_name);
     free(worksheet->vba_codename);
+    free(worksheet->vml_data_id_str);
 
     free(worksheet);
     worksheet = NULL;
@@ -758,6 +784,7 @@ _insert_cell_list(struct lxw_table_cells *cell_list,
     /* If existing_cell is not NULL, then that cell already existed. */
     /* Remove existing_cell and add new one in again. */
     if (existing_cell) {
+        existing_cell->comment = NULL;
         RB_REMOVE(lxw_table_cells, cell_list, existing_cell);
 
         /* Add it in again. */
@@ -776,6 +803,7 @@ _insert_cell(lxw_worksheet *self, lxw_row_t row_num, lxw_col_t col_num,
              lxw_cell *cell)
 {
     lxw_row *row = _get_row(self, row_num);
+    lxw_vml_obj *existing_comment = NULL;
 
     if (!self->optimize) {
         row->data_changed = LXW_TRUE;
@@ -786,10 +814,14 @@ _insert_cell(lxw_worksheet *self, lxw_row_t row_num, lxw_col_t col_num,
             row->data_changed = LXW_TRUE;
 
             /* Overwrite an existing cell if necessary. */
-            if (self->array[col_num])
+            if (self->array[col_num]) {
+                existing_comment = self->array[col_num]->comment;
+                self->array[col_num]->comment = NULL;
                 _free_cell(self->array[col_num]);
+            }
 
             self->array[col_num] = cell;
+            self->array[col_num]->comment = existing_comment;
         }
     }
 }
@@ -891,6 +923,9 @@ _cell_cmp(lxw_cell *cell1, lxw_cell *cell2)
     return 0;
 }
 
+/*
+ * Comparator for the image/hyperlink relationship ids.
+ */
 STATIC int
 _drawing_rel_id_cmp(lxw_drawing_rel_id *rel_id1, lxw_drawing_rel_id *rel_id2)
 {
@@ -2087,6 +2122,136 @@ _worksheet_position_object_emus(lxw_worksheet *self,
     drawing_object->row_absolute *= 9525;
 }
 
+/*
+ * This function handles the additional optional parameters to
+ * worksheet_write_comment_opt() as well as calculating the comment object
+ * position and vertices.
+ */
+void
+_get_comment_params(lxw_worksheet *self, lxw_vml_obj *comment,
+                    lxw_comment_options *options)
+{
+
+    lxw_row_t start_row;
+    lxw_col_t start_col;
+    int32_t x_offset;
+    int32_t y_offset;
+    lxw_object_properties object_props;
+    lxw_drawing_object drawing_object;
+    uint32_t height = 74;
+    uint32_t width = 128;
+    double x_scale = 1.0;
+    double y_scale = 1.0;
+    lxw_row_t row = comment->row;
+    lxw_col_t col = comment->col;;
+
+    /* Set the default start cell and offsets for the comment. These are
+     * generally fixed in relation to the parent cell. However there are some
+     * edge cases for cells at the, er, edges. */
+    if (row == 0)
+        y_offset = 2;
+    else if (row == LXW_ROW_MAX - 3)
+        y_offset = 16;
+    else if (row == LXW_ROW_MAX - 2)
+        y_offset = 16;
+    else if (row == LXW_ROW_MAX - 1)
+        y_offset = 14;
+    else
+        y_offset = 10;
+
+    if (col == LXW_COL_MAX - 3)
+        x_offset = 49;
+    else if (col == LXW_COL_MAX - 2)
+        x_offset = 49;
+    else if (col == LXW_COL_MAX - 1)
+        x_offset = 49;
+    else
+        x_offset = 15;
+
+    if (row == 0)
+        start_row = 0;
+    else if (row == LXW_ROW_MAX - 3)
+        start_row = LXW_ROW_MAX - 7;
+    else if (row == LXW_ROW_MAX - 2)
+        start_row = LXW_ROW_MAX - 6;
+    else if (row == LXW_ROW_MAX - 1)
+        start_row = LXW_ROW_MAX - 5;
+    else
+        start_row = row - 1;
+
+    if (col == LXW_COL_MAX - 3)
+        start_col = LXW_COL_MAX - 6;
+    else if (col == LXW_COL_MAX - 2)
+        start_col = LXW_COL_MAX - 5;
+    else if (col == LXW_COL_MAX - 1)
+        start_col = LXW_COL_MAX - 4;
+    else
+        start_col = col + 1;
+
+    /* Set any user defined options. */
+    if (options) {
+
+        if (options->width > 0.0)
+            width = options->width;
+
+        if (options->height > 0.0)
+            height = options->height;
+
+        if (options->x_scale > 0.0)
+            x_scale = options->x_scale;
+
+        if (options->y_scale > 0.0)
+            y_scale = options->y_scale;
+
+        if (options->x_offset != 0)
+            x_offset = options->x_offset;
+
+        if (options->y_offset != 0)
+            y_offset = options->y_offset;
+
+        if (options->start_row > 0 || options->start_col > 0) {
+            start_row = options->start_row;
+            start_col = options->start_col;
+        }
+
+        if (options->font_size > 0.0)
+            comment->font_size = options->font_size;
+
+        comment->color = options->color;
+        comment->author = lxw_strdup(options->author);
+        comment->font_name = lxw_strdup(options->font_name);
+        comment->font_family = lxw_strdup(options->font_family);
+    }
+
+    /* Scale the width/height to the default/user scale and round to the
+     * nearest pixel. */
+    width = (uint32_t) (0.5 + x_scale * width);
+    height = (uint32_t) (0.5 + y_scale * height);
+    comment->width = width;
+    comment->height = height;
+
+    object_props.col = start_col;
+    object_props.row = start_row;
+    object_props.x_offset = x_offset;
+    object_props.y_offset = y_offset;
+    object_props.width = width;
+    object_props.height = height;
+
+    _worksheet_position_object_pixels(self, &object_props, &drawing_object);
+
+    comment->from.col = drawing_object.from.col;
+    comment->from.row = drawing_object.from.row;
+    comment->from.col_offset = drawing_object.from.col_offset;
+    comment->from.row_offset = drawing_object.from.row_offset;
+    comment->to.col = drawing_object.to.col;
+    comment->to.row = drawing_object.to.row;
+    comment->to.col_offset = drawing_object.to.col_offset;
+    comment->to.row_offset = drawing_object.to.row_offset;
+    comment->col_absolute = drawing_object.col_absolute;
+    comment->row_absolute = drawing_object.row_absolute;
+
+}
+
 /*
  * Set up image/drawings.
  */
@@ -2142,7 +2307,6 @@ lxw_worksheet_prepare_image(lxw_worksheet *self,
     width *= 96.0 / object_props->x_dpi;
     height *= 96.0 / object_props->y_dpi;
 
-    /* Convert to the nearest pixel. */
     object_props->width = width;
     object_props->height = height;
 
@@ -2187,7 +2351,7 @@ lxw_worksheet_prepare_image(lxw_worksheet *self,
             relationship->target =
                 lxw_escape_url_characters(url + 1, LXW_TRUE);
             GOTO_LABEL_ON_MEM_ERROR(relationship->target, mem_error);
-            strncpy(relationship->target, "file:///", sizeof("file:///") - 1);
+            memcpy(relationship->target, "file:///", sizeof("file:///") -1);
         }
         else {
             relationship->target_mode = lxw_strdup("External");
@@ -2345,6 +2509,117 @@ lxw_worksheet_prepare_chart(lxw_worksheet *self,
     }
 }
 
+/*
+ * Set up VML objects, such as comments, in the worksheet.
+ */
+uint32_t
+lxw_worksheet_prepare_vml_objects(lxw_worksheet *self,
+                                  uint32_t vml_data_id,
+                                  uint32_t vml_shape_id,
+                                  uint32_t vml_drawing_id,
+                                  uint32_t comment_id)
+{
+    lxw_row *row;
+    lxw_cell *cell;
+    lxw_rel_tuple *relationship;
+    char filename[LXW_FILENAME_LENGTH];
+    uint32_t comment_count = 0;
+    uint32_t i;
+    uint32_t tmp_data_id;
+    size_t data_str_len = 0;
+    size_t used = 0;
+    char *vml_data_id_str;
+
+    RB_FOREACH(row, lxw_table_rows, self->table) {
+        if (row->has_comments) {
+            RB_FOREACH(cell, lxw_table_cells, row->cells) {
+                if (cell->comment) {
+                    STAILQ_INSERT_TAIL(self->comment_objs, cell->comment,
+                                       list_pointers);
+                    comment_count++;
+                }
+            }
+        }
+    }
+
+    relationship = calloc(1, sizeof(lxw_rel_tuple));
+    GOTO_LABEL_ON_MEM_ERROR(relationship, mem_error);
+
+    relationship->type = lxw_strdup("/vmlDrawing");
+    GOTO_LABEL_ON_MEM_ERROR(relationship->type, mem_error);
+
+    lxw_snprintf(filename, 32, "../drawings/vmlDrawing%d.vml",
+                 vml_drawing_id);
+
+    relationship->target = lxw_strdup(filename);
+    GOTO_LABEL_ON_MEM_ERROR(relationship->target, mem_error);
+
+    self->external_vml_comment_link = relationship;
+
+    if (self->has_comments) {
+
+        relationship = calloc(1, sizeof(lxw_rel_tuple));
+        GOTO_LABEL_ON_MEM_ERROR(relationship, mem_error);
+
+        relationship->type = lxw_strdup("/comments");
+        GOTO_LABEL_ON_MEM_ERROR(relationship->type, mem_error);
+
+        lxw_snprintf(filename, 32, "../comments%d.xml", comment_id);
+
+        relationship->target = lxw_strdup(filename);
+        GOTO_LABEL_ON_MEM_ERROR(relationship->target, mem_error);
+
+        self->external_comment_link = relationship;
+    }
+
+    /* The vml.c <o:idmap> element data id contains a comma separated range
+     * when there is more than one 1024 block of comments, like this:
+     * data="1,2,3". Since this could potentially (but unlikely) exceed
+     * LXW_MAX_ATTRIBUTE_LENGTH we need to allocate space dynamically. */
+
+    /* Calculate the total space required for the ID for each 1024 block. */
+    for (i = 0; i <= comment_count / 1024; i++) {
+        tmp_data_id = vml_data_id + i;
+
+        /* Calculate the space required for the digits in the id. */
+        while (tmp_data_id) {
+            data_str_len++;
+            tmp_data_id /= 10;
+        }
+
+        /* Add an extra char for comma separator or '\O'. */
+        data_str_len++;
+    };
+
+    /* If this allocation fails it will be dealt with in packager.c. */
+    vml_data_id_str = calloc(1, data_str_len);
+    GOTO_LABEL_ON_MEM_ERROR(vml_data_id_str, mem_error);
+
+    /* Create the CSV list in the allocated space. */
+    for (i = 0; i <= comment_count / 1024; i++) {
+        tmp_data_id = vml_data_id + i;
+        lxw_snprintf(vml_data_id_str + used, data_str_len - used, "%d,",
+                     tmp_data_id);
+
+        used = strlen(vml_data_id_str);
+    };
+
+    self->vml_shape_id = vml_shape_id;
+    self->vml_data_id_str = vml_data_id_str;
+
+    return comment_count;
+
+mem_error:
+    if (relationship) {
+        free(relationship->type);
+        free(relationship->target);
+        free(relationship->target_mode);
+        free(relationship);
+    }
+
+    return 0;
+}
+
 /*
  * Extract width and height information from a PNG file.
  */
@@ -2986,7 +3261,8 @@ _write_cell(lxw_worksheet *self, lxw_cell *cell, lxw_format *row_format)
         lxw_xml_end_tag(self->file, "c");
     }
     else if (cell->type == BLANK_CELL) {
-        lxw_xml_empty_tag(self->file, "c", &attributes);
+        if (cell->format)
+            lxw_xml_empty_tag(self->file, "c", &attributes);
     }
     else if (cell->type == BOOLEAN_CELL) {
         LXW_PUSH_ATTRIBUTES_STR("t", "b");
@@ -3032,10 +3308,13 @@ _worksheet_write_rows(lxw_worksheet *self)
 
             _write_row(self, row, spans);
 
-            RB_FOREACH(cell, lxw_table_cells, row->cells) {
-                _write_cell(self, cell, row->format);
+            if (row->data_changed) {
+                RB_FOREACH(cell, lxw_table_cells, row->cells) {
+                    _write_cell(self, cell, row->format);
+                }
+
+                lxw_xml_end_tag(self->file, "row");
             }
-            lxw_xml_end_tag(self->file, "row");
         }
     }
 }
@@ -3696,6 +3975,31 @@ _worksheet_write_sheet_protection(lxw_worksheet *self,
     LXW_FREE_ATTRIBUTES();
 }
 
+/*
+ * Write the <legacyDrawing> element.
+ */
+STATIC void
+_worksheet_write_legacy_drawing(lxw_worksheet *self)
+{
+    struct xml_attribute_list attributes;
+    struct xml_attribute *attribute;
+    char r_id[LXW_MAX_ATTRIBUTE_LENGTH];
+
+    if (!self->has_vml)
+        return;
+    else
+        self->rel_count++;
+
+    lxw_snprintf(r_id, LXW_ATTR_32, "rId%d", self->rel_count);
+    LXW_INIT_ATTRIBUTES();
+    LXW_PUSH_ATTRIBUTES_STR("r:id", r_id);
+
+    lxw_xml_empty_tag(self->file, "legacyDrawing", &attributes);
+
+    LXW_FREE_ATTRIBUTES();
+
+}
+
 /*
  * Write the <drawing> element.
  */
@@ -3707,9 +4011,7 @@ _worksheet_write_drawing(lxw_worksheet *self, uint16_t id)
     char r_id[LXW_MAX_ATTRIBUTE_LENGTH];
 
     lxw_snprintf(r_id, LXW_ATTR_32, "rId%d", id);
-
     LXW_INIT_ATTRIBUTES();
-
     LXW_PUSH_ATTRIBUTES_STR("r:id", r_id);
 
     lxw_xml_empty_tag(self->file, "drawing", &attributes);
@@ -4065,6 +4367,9 @@ lxw_worksheet_assemble_xml_file(lxw_worksheet *self)
     /* Write the drawing element. */
     _worksheet_write_drawings(self);
 
+    /* Write the legacyDrawing element. */
+    _worksheet_write_legacy_drawing(self);
+
     /* Close the worksheet tag. */
     lxw_xml_end_tag(self->file, "worksheet");
 }
@@ -4316,10 +4621,6 @@ worksheet_write_blank(lxw_worksheet *self,
     lxw_cell *cell;
     lxw_error err;
 
-    /* Blank cells without formatting are ignored by Excel. */
-    if (!format)
-        return LXW_NO_ERROR;
-
     err = _check_dimensions(self, row_num, col_num, LXW_FALSE, LXW_FALSE);
     if (err)
         return err;
@@ -4343,7 +4644,6 @@ worksheet_write_boolean(lxw_worksheet *self,
     lxw_error err;
 
     err = _check_dimensions(self, row_num, col_num, LXW_FALSE, LXW_FALSE);
-
     if (err)
         return err;
 
@@ -4735,6 +5035,96 @@ worksheet_write_rich_string(lxw_worksheet *self,
     return LXW_ERROR_MEMORY_MALLOC_FAILED;
 }
 
+/*
+ * Write a comment to a worksheet cell in Excel.
+ */
+lxw_error
+worksheet_write_comment_opt(lxw_worksheet *self,
+                            lxw_row_t row_num, lxw_col_t col_num,
+                            char *text, lxw_comment_options *options)
+{
+    lxw_row *row;
+    lxw_cell *cell;
+    lxw_error err;
+    lxw_vml_obj *comment;
+    uint8_t data_changed = LXW_FALSE;
+
+    if (self->optimize) {
+        LXW_WARN("worksheet_write_comment/opt(): "
+                 "Not supported in 'constant_memory' mode.");
+
+        return LXW_ERROR_FEATURE_NOT_SUPPORTED;
+    }
+
+    err = _check_dimensions(self, row_num, col_num, LXW_FALSE, LXW_FALSE);
+    if (err)
+        return err;
+
+    if (!text)
+        return LXW_ERROR_NULL_PARAMETER_IGNORED;
+
+    if (lxw_utf8_strlen(text) > LXW_STR_MAX)
+        return LXW_ERROR_MAX_STRING_LENGTH_EXCEEDED;
+
+    comment = calloc(1, sizeof(lxw_vml_obj));
+    GOTO_LABEL_ON_MEM_ERROR(comment, mem_error);
+
+    comment->text = lxw_strdup(text);
+    GOTO_LABEL_ON_MEM_ERROR(comment->text, mem_error);
+
+    row = lxw_worksheet_find_row(self, row_num);
+    if (row)
+        data_changed = row->data_changed;
+
+    cell = lxw_worksheet_find_cell_in_row(row, col_num);
+    if (cell) {
+        free(cell->comment);
+    }
+    else {
+        /* If there isn't an existing cell we use a new blank cell. */
+        cell = _new_blank_cell(row_num, col_num, NULL);
+        _insert_cell(self, row_num, col_num, cell);
+    }
+
+    comment->row = row_num;
+    comment->col = col_num;
+
+    /* Set user and default parameters and dimensions for the comment. */
+    _get_comment_params(self, comment, options);
+
+    cell->comment = comment;
+
+    if (!row) {
+        row = lxw_worksheet_find_row(self, row_num);
+        row->data_changed = LXW_FALSE;
+    }
+    else {
+        row->data_changed = data_changed;
+    }
+
+    row->has_comments = LXW_TRUE;
+    self->has_vml = LXW_TRUE;
+    self->has_comments = LXW_TRUE;
+
+    return LXW_NO_ERROR;
+
+mem_error:
+    if (comment)
+        _free_vml_object(comment);
+
+    return LXW_ERROR_MEMORY_MALLOC_FAILED;
+}
+
+/*
+ * Write a comment to a worksheet cell in Excel.
+ */
+lxw_error
+worksheet_write_comment(lxw_worksheet *self,
+                        lxw_row_t row_num, lxw_col_t col_num, char *string)
+{
+    return worksheet_write_comment_opt(self, row_num, col_num, string, NULL);
+}
+
 /*
  * Set the properties of a single column or a range of columns with options.
  */
@@ -5960,7 +6350,6 @@ worksheet_insert_chart_opt(lxw_worksheet *self,
     object_props->row = row_num;
     object_props->col = col_num;
 
-    /* TODO. Read defaults from chart. */
     object_props->width = 480;
     object_props->height = 288;
 
@@ -6289,3 +6678,15 @@ worksheet_set_vba_name(lxw_worksheet *self, const char *name)
 
     return LXW_NO_ERROR;
 }
+
+/*
+ * Set the default author of the cell comments.
+ */
+lxw_error
+worksheet_set_comments_author(lxw_worksheet *self, const char *author)
+{
+    (void) self;
+    (void) author;
+
+    return LXW_NO_ERROR;
+}
diff --git a/test/functional/base_test_class.py b/test/functional/base_test_class.py
index 4e6c6363..bde88009 100644
--- a/test/functional/base_test_class.py
+++ b/test/functional/base_test_class.py
@@ -17,7 +17,7 @@ class XLSXBaseTest(unittest.TestCase):
     """
 
     def setUp(self):
-        self.maxDiff = None
+        self.maxDiff = 10
 
         self.no_system_error = 0
         self.got_filename = ''
diff --git a/test/functional/src/test_comment01.c b/test/functional/src/test_comment01.c
new file mode 100644
index 00000000..51012a46
--- /dev/null
+++ b/test/functional/src/test_comment01.c
@@ -0,0 +1,23 @@
+/*****************************************************************************
+ * Test cases for libxlsxwriter.
+ *
+ * Test to compare output against Excel files.
+ *
+ * Copyright 2014-2019, John McNamara, jmcnamara@cpan.org
+ *
+ */
+
+#include "xlsxwriter.h"
+
+int main() {
+
+    lxw_workbook  *workbook  = workbook_new("test_comment01.xlsx");
+    lxw_worksheet *worksheet = workbook_add_worksheet(workbook, NULL);
+
+    worksheet_write_string(worksheet, CELL("A1"), "Foo" , NULL);
+    worksheet_write_comment(worksheet, CELL("B2"), "Some text");
+
+    worksheet_set_comments_author(worksheet, "John");
+
+    return workbook_close(workbook);
+}
diff --git a/test/functional/src/test_comment02.c b/test/functional/src/test_comment02.c
new file mode 100644
index 00000000..50c5d8df
--- /dev/null
+++ b/test/functional/src/test_comment02.c
@@ -0,0 +1,24 @@
+/*****************************************************************************
+ * Test cases for libxlsxwriter.
+ *
+ * Test to compare output against Excel files.
+ *
+ * Copyright 2014-2019, John McNamara, jmcnamara@cpan.org
+ *
+ */
+
+#include "xlsxwriter.h"
+
+int main() {
+
+    lxw_workbook  *workbook  = workbook_new("test_comment02.xlsx");
+    lxw_worksheet *worksheet = workbook_add_worksheet(workbook, NULL);
+
+    worksheet_write_string(worksheet, CELL("A1"), "Foo" , NULL);
+    worksheet_write_comment(worksheet, CELL("B2"), "Some text");
+    worksheet_write_comment(worksheet, CELL("D17"), "More text");
+
+    worksheet_set_comments_author(worksheet, "John");
+
+    return workbook_close(workbook);
+}
diff --git a/test/functional/src/test_comment03.c b/test/functional/src/test_comment03.c
new file mode 100644
index 00000000..da7c7ae0
--- /dev/null
+++ b/test/functional/src/test_comment03.c
@@ -0,0 +1,24 @@
+/*****************************************************************************
+ * Test cases for libxlsxwriter.
+ *
+ * Test to compare output against Excel files.
+ *
+ * Copyright 2014-2019, John McNamara, jmcnamara@cpan.org
+ *
+ */
+
+#include "xlsxwriter.h"
+
+int main() {
+
+    lxw_workbook  *workbook  = workbook_new("test_comment03.xlsx");
+    lxw_worksheet *worksheet = workbook_add_worksheet(workbook, NULL);
+
+    worksheet_write_string(worksheet, CELL("A1"), "Foo" , NULL);
+    worksheet_write_comment(worksheet, CELL("A1"), "Some text");
+    worksheet_write_comment(worksheet, CELL("XFD1048576"), "Some text");
+
+    worksheet_set_comments_author(worksheet, "John");
+
+    return workbook_close(workbook);
+}
diff --git a/test/functional/src/test_comment04.c b/test/functional/src/test_comment04.c
new file mode 100644
index 00000000..d1948d67
--- /dev/null
+++ b/test/functional/src/test_comment04.c
@@ -0,0 +1,31 @@
+/*****************************************************************************
+ * Test cases for libxlsxwriter.
+ *
+ * Test to compare output against Excel files.
+ *
+ * Copyright 2014-2019, John McNamara, jmcnamara@cpan.org
+ *
+ */
+
+#include "xlsxwriter.h"
+
+int main() {
+
+    lxw_workbook  *workbook  = workbook_new("test_comment04.xlsx");
+    lxw_worksheet *worksheet1 = workbook_add_worksheet(workbook, NULL);
+    lxw_worksheet *worksheet2 = workbook_add_worksheet(workbook, NULL);
+    lxw_worksheet *worksheet3 = workbook_add_worksheet(workbook, NULL);
+
+    (void)worksheet2;
+
+    worksheet_write_string(worksheet1, CELL("A1"), "Foo" , NULL);
+    worksheet_write_comment(worksheet1, CELL("B2"), "Some text");
+
+    worksheet_write_string(worksheet3, CELL("A1"), "Bar" , NULL);
+    worksheet_write_comment(worksheet3, CELL("C7"), "More text");
+
+    worksheet_set_comments_author(worksheet1, "John");
+    worksheet_set_comments_author(worksheet3, "John");
+
+    return workbook_close(workbook);
+}
diff --git a/test/functional/src/test_comment05.c b/test/functional/src/test_comment05.c
new file mode 100644
index 00000000..bad20dae
--- /dev/null
+++ b/test/functional/src/test_comment05.c
@@ -0,0 +1,33 @@
+/*****************************************************************************
+ * Test cases for libxlsxwriter.
+ *
+ * Test to compare output against Excel files.
+ *
+ * Copyright 2014-2019, John McNamara, jmcnamara@cpan.org
+ *
+ */
+
+#include "xlsxwriter.h"
+
+int main() {
+
+    lxw_workbook  *workbook  = workbook_new("test_comment05.xlsx");
+    lxw_worksheet *worksheet1 = workbook_add_worksheet(workbook, NULL);
+    lxw_worksheet *worksheet2 = workbook_add_worksheet(workbook, NULL);
+    lxw_worksheet *worksheet3 = workbook_add_worksheet(workbook, NULL);
+    uint32_t row;
+    uint16_t col;
+
+    (void)worksheet2;
+
+    for (row = 0; row <= 127; row++)
+        for (col = 0; col <= 15; col++)
+            worksheet_write_comment(worksheet1, row, col, "Some text");
+
+    worksheet_write_comment(worksheet3, CELL("A1"), "More text");
+
+    worksheet_set_comments_author(worksheet1, "John");
+    worksheet_set_comments_author(worksheet3, "John");
+
+    return workbook_close(workbook);
+}
diff --git a/test/functional/test_comment.py b/test/functional/test_comment.py
new file mode 100644
index 00000000..81f12078
--- /dev/null
+++ b/test/functional/test_comment.py
@@ -0,0 +1,29 @@
+###############################################################################
+#
+# Tests for libxlsxwriter.
+#
+# Copyright 2014-2019, John McNamara, jmcnamara@cpan.org
+#
+
+import base_test_class
+
+class TestCompareXLSXFiles(base_test_class.XLSXBaseTest):
+    """
+    Test file created with libxlsxwriter against a file created by Excel.
+
+    """
+
+    def test_comment01(self):
+        self.run_exe_test('test_comment01')
+
+    def test_comment02(self):
+        self.run_exe_test('test_comment02')
+
+    def test_comment03(self):
+        self.run_exe_test('test_comment03')
+
+    def test_comment04(self):
+        self.run_exe_test('test_comment04')
+
+    def test_comment05(self):
+        self.run_exe_test('test_comment05')
diff --git a/test/functional/xlsx_files/comment01.xlsx b/test/functional/xlsx_files/comment01.xlsx
new file mode 100644
index 00000000..69a9c208
Binary files /dev/null and b/test/functional/xlsx_files/comment01.xlsx differ
diff --git a/test/functional/xlsx_files/comment02.xlsx b/test/functional/xlsx_files/comment02.xlsx
new file mode 100644
index 00000000..d4614713
Binary files /dev/null and b/test/functional/xlsx_files/comment02.xlsx differ
diff --git a/test/functional/xlsx_files/comment03.xlsx b/test/functional/xlsx_files/comment03.xlsx
new file mode 100644
index 00000000..b8c9c386
Binary files /dev/null and b/test/functional/xlsx_files/comment03.xlsx differ
diff --git a/test/functional/xlsx_files/comment04.xlsx b/test/functional/xlsx_files/comment04.xlsx
new file mode 100644
index 00000000..2bc1bcdd
Binary files /dev/null and b/test/functional/xlsx_files/comment04.xlsx differ
diff --git a/test/functional/xlsx_files/comment05.xlsx b/test/functional/xlsx_files/comment05.xlsx
new file mode 100644
index 00000000..cf13891d
Binary files /dev/null and b/test/functional/xlsx_files/comment05.xlsx differ
diff --git a/test/unit/Makefile b/test/unit/Makefile
index 0fa27df4..a756836a 100644
--- a/test/unit/Makefile
+++ b/test/unit/Makefile
@@ -38,6 +38,8 @@ SRCS += $(wildcard drawing/test*.c)
 SRCS += $(wildcard chart/test*.c)
 SRCS += $(wildcard custom/test*.c)
 SRCS += $(wildcard chartsheet/test*.c)
+SRCS += $(wildcard vml/test*.c)
+SRCS += $(wildcard comment/test*.c)
 # End of SRCS
 
 OBJS  = $(patsubst %.c,%.o,$(SRCS))
@@ -72,6 +74,8 @@ all :
 	$(Q)$(MAKE) -C chart
 	$(Q)$(MAKE) -C custom
 	$(Q)$(MAKE) -C chartsheet
+	$(Q)$(MAKE) -C vml
+	$(Q)$(MAKE) -C comment
 # END make all
 
 clean :
@@ -90,6 +94,8 @@ clean :
 	$(Q)$(MAKE) clean -C chart
 	$(Q)$(MAKE) clean -C custom
 	$(Q)$(MAKE) clean -C chartsheet
+	$(Q)$(MAKE) clean -C vml
+	$(Q)$(MAKE) clean -C comment
 # END make clean
 
 
diff --git a/test/unit/comment/Makefile b/test/unit/comment/Makefile
new file mode 100644
index 00000000..2c05b8e2
--- /dev/null
+++ b/test/unit/comment/Makefile
@@ -0,0 +1,8 @@
+###############################################################################
+#
+# Makefile for libxlsxwriter library.
+#
+# Copyright 2014-2015, John McNamara, jmcnamara@cpan.org
+#
+
+include ../Makefile.unit
diff --git a/test/unit/comment/main.c b/test/unit/comment/main.c
new file mode 100644
index 00000000..086baf3a
--- /dev/null
+++ b/test/unit/comment/main.c
@@ -0,0 +1,15 @@
+/*
+ * Test runner for xmlwriter using ctest.
+ *
+ * Copyright 2014-2019 John McNamara, jmcnamara@cpan.org
+ *
+ */
+#define CTEST_MAIN
+
+#include "../ctest.h"
+
+int main(int argc, const char *argv[])
+{
+    return ctest_main(argc, argv);
+}
+
diff --git a/test/unit/comment/test_comment_xml_declaration.c b/test/unit/comment/test_comment_xml_declaration.c
new file mode 100644
index 00000000..adc8e43b
--- /dev/null
+++ b/test/unit/comment/test_comment_xml_declaration.c
@@ -0,0 +1,28 @@
+/*
+ * Tests for the libxlsxwriter library.
+ *
+ * Copyright 2014-2019, John McNamara, jmcnamara@cpan.org
+ *
+ */
+
+#include "../ctest.h"
+#include "../helper.h"
+
+#include "xlsxwriter/comment.h"
+
+// Test _xml_declaration().
+CTEST(comment, xml_declaration) {
+
+    char* got;
+    char exp[] = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"yes\"?>\n";
+    FILE* testfile = tmpfile();
+
+    lxw_comment *comment = lxw_comment_new();
+    comment->file = testfile;
+
+    _comment_xml_declaration(comment);
+
+    RUN_XLSX_STREQ(exp, got);
+
+    lxw_comment_free(comment);
+}
diff --git a/test/unit/vml/Makefile b/test/unit/vml/Makefile
new file mode 100644
index 00000000..b0a0426d
--- /dev/null
+++ b/test/unit/vml/Makefile
@@ -0,0 +1,8 @@
+###############################################################################
+#
+# Makefile for libxlsxwriter library.
+#
+# Copyright 2014-2019, John McNamara, jmcnamara@cpan.org
+#
+
+include ../Makefile.unit
diff --git a/test/unit/vml/main.c b/test/unit/vml/main.c
new file mode 100644
index 00000000..086baf3a
--- /dev/null
+++ b/test/unit/vml/main.c
@@ -0,0 +1,15 @@
+/*
+ * Test runner for xmlwriter using ctest.
+ *
+ * Copyright 2014-2019 John McNamara, jmcnamara@cpan.org
+ *
+ */
+#define CTEST_MAIN
+
+#include "../ctest.h"
+
+int main(int argc, const char *argv[])
+{
+    return ctest_main(argc, argv);
+}
+
